/*
 * To change this license header, choose License Headers in Project Properties.
 * To change this template file, choose Tools | Templates
 * and open the template in the editor.
 */
package Interface;

import DAO.CategoriasDao;
import DAO.MarcasVeiculosDao;
import Model.Categorias;
import Model.MarcasVeiculos;
import java.awt.Font;
import java.sql.SQLException;
import java.util.List;
import java.util.logging.Level;
import java.util.logging.Logger;
import javax.swing.JOptionPane;

/**
 *
 * @author Maiara-PC
 */
public class CadMarcas extends javax.swing.JInternalFrame {

    private static final long serialVersionUID = -2703408335378998347L;

    private MarcasVeiculosDao dao = new MarcasVeiculosDao();
    private MarcasVeiculos marcasVeiculos = new MarcasVeiculos();
    private List<Categorias> listaCategoria = null;
    private CategoriasDao cdao = new CategoriasDao();

    /**
     * Creates new form ListaFuncionario
     */
    public CadMarcas() {
        initComponents();

        carregaCombo();
    }

    public void atualizaTabela() {

        for (int i = 0; i < listaCategoria.size(); i++) {
            if (cbCategoria.getSelectedItem().equals(listaCategoria.get(i).getCategoria())) {
                dao.listarJTable(tabelaMarca, listaCategoria.get(i).getId());
                tabelaMarca.setFont(new Font("Sansserif", Font.PLAIN, 18));
                tabelaMarca.getColumnModel().getColumn(0).setHeaderValue("Código");
                tabelaMarca.getColumnModel().getColumn(1).setHeaderValue("Marca");
                System.out.println("aaaa");
            }

        }

    }

    public void limpar() {
        txtId.setText("");
        txtMarca.setText("");

    }

    /**
     * This method is called from within the constructor to initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is always
     * regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        PainelFundo = new javax.swing.JPanel();
        jPanel2 = new javax.swing.JPanel();
        jLabel2 = new javax.swing.JLabel();
        jLabel1 = new javax.swing.JLabel();
        txtId = new javax.swing.JTextField();
        txtMarca = new javax.swing.JTextField();
        btSalvar = new javax.swing.JButton();
        btAlterar = new javax.swing.JButton();
        btExcluir = new javax.swing.JButton();
        btLimpar = new javax.swing.JButton();
        jPanel1 = new javax.swing.JPanel();
        jScrollPane1 = new javax.swing.JScrollPane();
        tabelaMarca = new javax.swing.JTable();
        cbCategoria = new javax.swing.JComboBox<>();
        jLabel15 = new javax.swing.JLabel();

        setBackground(new java.awt.Color(194, 195, 198));
        setMaximumSize(new java.awt.Dimension(1024, 768));
        setMinimumSize(new java.awt.Dimension(1024, 768));
        setPreferredSize(new java.awt.Dimension(1024, 768));

        PainelFundo.setBackground(new java.awt.Color(117, 21, 30));
        PainelFundo.setBorder(javax.swing.BorderFactory.createTitledBorder(null, "Cadastro de Marcas", javax.swing.border.TitledBorder.CENTER, javax.swing.border.TitledBorder.DEFAULT_POSITION, new java.awt.Font("sansserif", 1, 18), new java.awt.Color(255, 255, 255))); // NOI18N
        PainelFundo.setMaximumSize(new java.awt.Dimension(1024, 768));
        PainelFundo.setName(""); // NOI18N
        PainelFundo.setPreferredSize(new java.awt.Dimension(1024, 748));

        jPanel2.setBackground(new java.awt.Color(41, 49, 51));
        jPanel2.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(0, 0, 0), 2, true));

        jLabel2.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N
        jLabel2.setForeground(new java.awt.Color(255, 255, 255));
        jLabel2.setText("Marca:");

        jLabel1.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N
        jLabel1.setForeground(new java.awt.Color(255, 255, 255));
        jLabel1.setText("Código:");

        txtId.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N
        txtId.setEnabled(false);

        txtMarca.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N

        btSalvar.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N
        btSalvar.setIcon(new javax.swing.ImageIcon(getClass().getResource("/imagens/icones/confirma.png"))); // NOI18N
        btSalvar.setContentAreaFilled(false);
        btSalvar.setCursor(new java.awt.Cursor(java.awt.Cursor.DEFAULT_CURSOR));
        btSalvar.setFocusPainted(false);
        btSalvar.setHorizontalTextPosition(javax.swing.SwingConstants.CENTER);
        btSalvar.setInheritsPopupMenu(true);
        btSalvar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btSalvarActionPerformed(evt);
            }
        });

        btAlterar.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N
        btAlterar.setText("Alterar");
        btAlterar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btAlterarActionPerformed(evt);
            }
        });

        btExcluir.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N
        btExcluir.setText("Excluir");
        btExcluir.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btExcluirActionPerformed(evt);
            }
        });

        btLimpar.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N
        btLimpar.setText("Limpar");
        btLimpar.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                btLimparActionPerformed(evt);
            }
        });

        jPanel1.setBorder(new javax.swing.border.LineBorder(new java.awt.Color(153, 0, 0), 2, true));

        tabelaMarca.setBorder(javax.swing.BorderFactory.createLineBorder(new java.awt.Color(185, 0, 0)));
        tabelaMarca.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N
        tabelaMarca.setModel(new javax.swing.table.DefaultTableModel(
            new Object [][] {

            },
            new String [] {

            }
        ));
        tabelaMarca.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                tabelaMarcaMouseClicked(evt);
            }
        });
        jScrollPane1.setViewportView(tabelaMarca);

        javax.swing.GroupLayout jPanel1Layout = new javax.swing.GroupLayout(jPanel1);
        jPanel1.setLayout(jPanel1Layout);
        jPanel1Layout.setHorizontalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 931, Short.MAX_VALUE)
                .addContainerGap())
        );
        jPanel1Layout.setVerticalGroup(
            jPanel1Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel1Layout.createSequentialGroup()
                .addContainerGap()
                .addComponent(jScrollPane1, javax.swing.GroupLayout.DEFAULT_SIZE, 372, Short.MAX_VALUE)
                .addContainerGap())
        );

        cbCategoria.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N
        cbCategoria.addItemListener(new java.awt.event.ItemListener() {
            public void itemStateChanged(java.awt.event.ItemEvent evt) {
                cbCategoriaItemStateChanged(evt);
            }
        });

        jLabel15.setFont(new java.awt.Font("sansserif", 0, 18)); // NOI18N
        jLabel15.setForeground(new java.awt.Color(255, 255, 255));
        jLabel15.setText("Categoria:");

        javax.swing.GroupLayout jPanel2Layout = new javax.swing.GroupLayout(jPanel2);
        jPanel2.setLayout(jPanel2Layout);
        jPanel2Layout.setHorizontalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addGap(19, 19, 19)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(jLabel1)
                            .addComponent(jLabel2))
                        .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addComponent(txtId, javax.swing.GroupLayout.PREFERRED_SIZE, 50, javax.swing.GroupLayout.PREFERRED_SIZE)
                            .addComponent(txtMarca, javax.swing.GroupLayout.PREFERRED_SIZE, 232, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addContainerGap(661, Short.MAX_VALUE))
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(jLabel15)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.UNRELATED)
                                .addComponent(cbCategoria, javax.swing.GroupLayout.PREFERRED_SIZE, 300, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addGroup(jPanel2Layout.createSequentialGroup()
                                .addComponent(btSalvar)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btAlterar, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btExcluir, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE)
                                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                                .addComponent(btLimpar, javax.swing.GroupLayout.PREFERRED_SIZE, 107, javax.swing.GroupLayout.PREFERRED_SIZE))
                            .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                        .addGap(0, 0, Short.MAX_VALUE))))
        );
        jPanel2Layout.setVerticalGroup(
            jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(jPanel2Layout.createSequentialGroup()
                .addContainerGap()
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
                    .addGroup(jPanel2Layout.createSequentialGroup()
                        .addGap(9, 9, 9)
                        .addComponent(jLabel15))
                    .addComponent(cbCategoria, javax.swing.GroupLayout.PREFERRED_SIZE, 39, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel1)
                    .addComponent(txtId, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(jLabel2)
                    .addComponent(txtMarca, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addGroup(jPanel2Layout.createParallelGroup(javax.swing.GroupLayout.Alignment.BASELINE)
                    .addComponent(btSalvar)
                    .addComponent(btAlterar)
                    .addComponent(btExcluir)
                    .addComponent(btLimpar, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE))
                .addPreferredGap(javax.swing.LayoutStyle.ComponentPlacement.RELATED)
                .addComponent(jPanel1, javax.swing.GroupLayout.PREFERRED_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(20, 20, 20))
        );

        javax.swing.GroupLayout PainelFundoLayout = new javax.swing.GroupLayout(PainelFundo);
        PainelFundo.setLayout(PainelFundoLayout);
        PainelFundoLayout.setHorizontalGroup(
            PainelFundoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );
        PainelFundoLayout.setVerticalGroup(
            PainelFundoLayout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(jPanel2, javax.swing.GroupLayout.DEFAULT_SIZE, javax.swing.GroupLayout.DEFAULT_SIZE, Short.MAX_VALUE)
        );

        javax.swing.GroupLayout layout = new javax.swing.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addComponent(PainelFundo, javax.swing.GroupLayout.DEFAULT_SIZE, 1012, Short.MAX_VALUE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(javax.swing.GroupLayout.Alignment.LEADING)
            .addGroup(layout.createSequentialGroup()
                .addComponent(PainelFundo, javax.swing.GroupLayout.PREFERRED_SIZE, 641, javax.swing.GroupLayout.PREFERRED_SIZE)
                .addGap(0, 96, Short.MAX_VALUE))
        );

        setBounds(0, 0, 1024, 768);
    }// </editor-fold>//GEN-END:initComponents

    private void btSalvarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btSalvarActionPerformed
        for (int i = 0; i < listaCategoria.size(); i++) {
            if (cbCategoria.getSelectedItem().equals(listaCategoria.get(i).getCategoria())) {
                //seto o id da marca
                marcasVeiculos.setIdcategoria(listaCategoria.get(i).getId());
            }
        }
        if (txtMarca.getText().trim() == "") {
            //deve exibir uma mensagem de alerta
        } else {
            marcasVeiculos.setMarca(txtMarca.getText().toUpperCase());
            try {
                dao.inserir(marcasVeiculos);
                limpar();
                atualizaTabela();
                System.out.println("Marca inserida");
            } catch (SQLException ex) {
                System.out.println("erro na incerção-> " + ex);
                Logger.getLogger(CadCores.class.getName()).log(Level.SEVERE, null, ex);
            }
        }


    }//GEN-LAST:event_btSalvarActionPerformed

    private void btAlterarActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btAlterarActionPerformed
        marcasVeiculos = new MarcasVeiculos();
        marcasVeiculos.setId(Long.parseLong(txtId.getText()));
        marcasVeiculos.setMarca(txtMarca.getText().toUpperCase());
        for (int i = 0; i < listaCategoria.size(); i++) {
            if (cbCategoria.getSelectedItem().equals(listaCategoria.get(i).getCategoria())) {
                //seto o id da marca
                marcasVeiculos.setIdcategoria(listaCategoria.get(i).getId());
            }
        }
        try {
            dao.atualizar(marcasVeiculos);
            atualizaTabela();
            limpar();
        } catch (RuntimeException ex) {
            JOptionPane.showMessageDialog(this, "Erro ao atualizar Marca-->>" + ex);
        }
    }//GEN-LAST:event_btAlterarActionPerformed

    private void btExcluirActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btExcluirActionPerformed
        try {
            String i = tabelaMarca.getValueAt(tabelaMarca.getSelectedRow(), 0).toString();
            dao.deletar(i);
            limpar();
            atualizaTabela();
        } catch (RuntimeException ex) {
            JOptionPane.showMessageDialog(this, "Selecione uma Marca para excluir.");
        }
    }//GEN-LAST:event_btExcluirActionPerformed

    private void btLimparActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_btLimparActionPerformed
        limpar();
    }//GEN-LAST:event_btLimparActionPerformed
    private void carregaCombo() {
        try {
            cbCategoria.removeAllItems();
            cbCategoria.addItem("");
            // carrego minha lista
            listaCategoria = cdao.listaCategorias();
            for (int i = 0; i < listaCategoria.size(); i++) {
                //seto o texto no meu combobox
                cbCategoria.addItem(listaCategoria.get(i).getCategoria());
            }
            // Para pegar o id do texto é assim
            for (int i = 0; i < listaCategoria.size(); i++) {
                if (cbCategoria.getSelectedItem().equals(listaCategoria.get(i).getCategoria())) {
                    System.out.println(listaCategoria.get(i).getId());
                }
            }

        } catch (SQLException ex) {
            Logger.getLogger(CadMarcas.class.getName()).log(Level.SEVERE, null, ex);
        }
    }
    private void tabelaMarcaMouseClicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_tabelaMarcaMouseClicked
        limpar();
        txtId.setText(tabelaMarca.getValueAt(tabelaMarca.getSelectedRow(), 0).toString());
        txtMarca.setText(tabelaMarca.getValueAt(tabelaMarca.getSelectedRow(), 1).toString());
    }//GEN-LAST:event_tabelaMarcaMouseClicked

    private void cbCategoriaItemStateChanged(java.awt.event.ItemEvent evt) {//GEN-FIRST:event_cbCategoriaItemStateChanged
        if (evt.getStateChange() == 1) {
            System.out.println("0000000000000000000000000");
        } else if (evt.getStateChange() == 2) {
            atualizaTabela();
        }

    }//GEN-LAST:event_cbCategoriaItemStateChanged


    // Variables declaration - do not modify//GEN-BEGIN:variables
    public javax.swing.JPanel PainelFundo;
    public javax.swing.JButton btAlterar;
    public javax.swing.JButton btExcluir;
    public javax.swing.JButton btLimpar;
    public javax.swing.JButton btSalvar;
    public javax.swing.JComboBox<String> cbCategoria;
    public javax.swing.JLabel jLabel1;
    public javax.swing.JLabel jLabel15;
    public javax.swing.JLabel jLabel2;
    public javax.swing.JPanel jPanel1;
    public javax.swing.JPanel jPanel2;
    public javax.swing.JScrollPane jScrollPane1;
    public javax.swing.JTable tabelaMarca;
    public javax.swing.JTextField txtId;
    public javax.swing.JTextField txtMarca;
    // End of variables declaration//GEN-END:variables
}
